<?php
/*
 * Plugin Name: Spoiler Tags
 * Version: 1.0.3
 * Plugin URI: https://www.clockworkknight.com/flat
 * Description: This plugin adds spoiler tags to Flatpress that you can use in posts and static pages. This plugin requires the BBCode plugin. <a href="./fp-plugins/spoilertags/doc_spoilertags.txt" title="Instructions" target="_blank">[Instructions]</a>
 * Author: Tongara
 * Author URI: https://www.clockworkknight.com/
 * 
 * Changelog:
 * v1.0.3:	Added, css-file v0.2 with some design examples
 * Change-Date:	18.12.2022, by Fraenkiman
 * 
 * v1.0.2: 	*Fixed* The plugin crashes when the BBCode plugin is not enabled. Thanks to Arvid for the hint
 * Change-Date:	14.12.2022, by Fraenkiman
 * 
 * v1.0.1: 	*Added* polyfill-Java-Script for IE and Edge in the body
 * Change-Date:	15.10.2022, by Fraenkiman
 */
 
add_filter('init', 'plugin_spoilertags');

function plugin_spoilertags_style() {
    $pdir = plugin_geturl('spoilertags');
    echo '
	<!-- start of spoilertags plugin CSS -->
	<link rel="stylesheet" type="text/css" href="' . $pdir . 'res/spoilertags.css">
	<!-- end of spoilertags plugin CSS -->';
}
add_action('wp_head', 'plugin_spoilertags_style');


function plugin_spoilertags() {
    if (!function_exists('plugin_bbcode_init')) { // check if BBCode is enabled
	    return;
    }
    $bbcode = plugin_bbcode_init();
    $bbcode->addCode (
	'spoiler',
	'callback_replace',
	'plugin_spoilertags_callback',
	array('usecontent_param' => array ('default')),
	'inline',
	array ('listitem', 'block', 'inline', 'link'),
	array ());
 
    $bbcode->setCodeFlag ('spoiler', 'closetag', BBCODE_CLOSETAG_MUSTEXIST);
}
 
function plugin_spoilertags_callback($action, $attributes, $content, $params, $node_object) { 
     if ($action == 'validate') {
//
        return true;
     }
    
 if (empty($attributes)) {
     return "<details><summary>Spoiler</summary>$content</details>";
    } else {
    return "<details><summary>{$attributes['default']}</summary>$content</details>";
}}

function plugin_spoilertags_footer() {
	$pdir = plugin_geturl('spoilertags');
	echo '
		<!-- start of spoilertags plugin IE/Edge-Helper -->
		<script src="' . $pdir . 'res/index.min.js" async></script>
		<!-- end of spoilertags plugin IE/Edge-Helper -->';
}
add_action('wp_footer', 'plugin_spoilertags_footer');

?>
